﻿using System.Collections.Generic;
using System.Linq;

namespace EonaCat.HID
{
    public class Enumerator : IEnumerator
    {
        public bool IsConnected(string devicePath)
        {
            return Devices.IsConnected(devicePath);
        }

        public IDevice GetDevice(string devicePath)
        {
            return Devices.GetDevice(devicePath) as IDevice;
        }

        public IEnumerable<IDevice> Enumerate()
        {
            return Devices.Enumerate().
                Select(d => d as IDevice);
        }

        public IEnumerable<IDevice> Enumerate(string devicePath)
        {
            return Devices.Enumerate(devicePath).
                Select(d => d as IDevice);
        }

        public IEnumerable<IDevice> Enumerate(int vendorId, params int[] productIds)
        {
            return Devices.Enumerate(vendorId, productIds).
                Select(d => d as IDevice);
        }

        public IEnumerable<IDevice> Enumerate(int vendorId)
        {
            return Devices.Enumerate(vendorId).
                Select(d => d as IDevice);
        }
    }
}
